/* Author: Derek O Reilly, Dundalk Institute of Technology, Ireland. */

class Monster extends GameObject
{
    /* Each gameObject MUST have a constructor() and a render() method.        */
    /* If the object animates, then it must also have an updateState() method. */

    constructor(monsterImage)
    {
        super(5); /* as this class extends from GameObject, you must always call super() */

        /* These variables depend on the object */
        this.startX = 20;
        this.startY = 20;
        this.x = this.startX;
        this.y = this.startY;

        this.monsterImage = monsterImage;
        this.width = 40;
        this.height = 40;
        this.setDirection(STOPPED);
    }

    updateState()
    {
        if (this.direction === UP)
        {
            this.y--;
        }
        else if (this.direction === LEFT)
        {
            this.x--;
        }
        else if (this.direction === DOWN)
        {
            this.y++;
        }
        else if (this.direction === RIGHT)
        {
            this.x++;
        }
    }

    render()
    {
        ctx.drawImage(this.monsterImage, this.x, this.y, this.width, this.height);
    }

    setDirection(newDirection)
    {
        if (this.direction !== START)
        {
            this.direction = newDirection;
        }
        else // spacebar hit, so set monster back to start
        {
            this.x = this.startX;
            this.y = this.startY;
            this.direction = STOPPED;
        }
    }

    getDirection()
    {
        return(this.direction);
    }

    getX()
    {
        return this.x;
    }

    getY()
    {
        return this.y;
    }

    setX(newX)
    {
        this.x = newX;
    }

    setY(newY)
    {
        this.y = newY;
    }
    getWidth()
    {
        return this.width;
    }

    getHeight()
    {
        return this.height;
    }
}